############################################################## 
## MOD Title: Topic Preview
## MOD Author: Porutchik < garnitur356 [at] mail15.com > (Sergey) http://forum.aeroion.ru 
## MOD Author: pukapuka <pukalite@gmail.com> (N/A) www.lazyphp.net
## MOD Description: This Mod adds the ability to preview a topic (the first post of topic) in a forum. 
##					The preview text length can be changed in control panel. 
##					People now can preview the lastest post of each topic.
##					Part 1: Required base part for the mod.
## MOD Version: 1.0.2
## 
## Installation Level: Easy 
## Installation Time: ~10 Minutes 
## Files To Edit (9):
##		viewforum.php
##		admin/admin_board.php
##		includes/bbcode.php
##		includes/functions.php
##		language/lang_english/lang_admin.php
##		templates/subSilver/admin/board_config_body.tpl
##		templates/subSilver/viewforum_body.tpl
##		templates/subSilver/overall_header.tpl
##		templates/subSilver/subSilver.css
##
## Included Files: (1)
##		topic_preview.js
##
## License: http://opensource.org/licenses/gpl-license.php GNU General Public License v2 
############################################################## 
## For security purposes, please check: http://www.phpbb.com/mods/ 
## for the latest version of this MOD. Although MODs are checked 
## before being allowed in the MODs Database there is no guarantee 
## that there are no security problems within the MOD. No support 
## will be given for MODs not found within the MODs Database which 
## can be found at http://www.phpbb.com/mods/ 
############################################################## 
## Author Notes: 
## 
## MOD original author: pukapuka <pukalite@gmail.com> www.lazyphp.net
## 
##
############################################################## 
## MOD History: 
##	
##	2007-02-26 	- Version 1.0.2
##			- modify instructions to be Topics Sorted By Type At Forum View by Xpert compliant
##	2006-11-21 	- Version 1.0.1
##			- small change code
##	2006-09-07 	- Version 1.0.0
##			- Initial Release
## 
############################################################## 
## Before Adding This MOD To Your Forum, You Should Back Up All Files Related To This MOD 
############################################################## 

#
#-----[ SQL ]-------------------------------------------
#
INSERT INTO phpbb_config (config_name, config_value) VALUES ('topic_preview_length', '150');

#
#-----[ COPY ]------------------------------------------
#
copy topic_preview.js to templates/topic_preview.js

# 
#-----[ OPEN ]--------------------------------------------- 
# 
viewforum.php

#
#-----[ FIND ]---------------------------------------------
#
include($phpbb_root_path . 'common.'.$phpEx);

# 
#-----[ AFTER, ADD ]-------------------------------------- 
#
include_once($phpbb_root_path . 'includes/bbcode.'.$phpEx);

#
#-----[ FIND ]---------------------------------------------
#
if( $total_topics )
{

# 
#-----[ AFTER, ADD ]-------------------------------------- 
#
	$post_text_list = get_preview_text($topic_rowset, $board_config['topic_preview_length']);

#
#-----[ FIND ]---------------------------------------------
#
		$last_post_url = '<a href="' . append_sid("viewtopic.$phpEx?"  . POST_POST_URL . '=' . $topic_rowset[$i]['topic_last_post_id']) . '#' . $topic_rowset[$i]['topic_last_post_id'] . '"><img src="' . $images['icon_latest_reply'] . '" alt="' . $lang['View_latest_post'] . '" title="' . $lang['View_latest_post'] . '" border="0" /></a>';

#
#-----[ REPLACE WITH ]---------------------------------------------
#
		$last_post_url = append_sid("viewtopic.$phpEx?"  . POST_POST_URL . '=' . $topic_rowset[$i]['topic_last_post_id']) . '#' . $topic_rowset[$i]['topic_last_post_id'];

#
#-----[ FIND ]---------------------------------------------
#
		$views = $topic_rowset[$i]['topic_views'];

# 
#-----[ BEFORE, ADD ]-------------------------------------- 
#
		$poster_id = $topic_rowset[$i]['user_id'];
		$topic_preview = $post_text_list[$topic_rowset[$i]['topic_first_post_id']];
		
#
#-----[ FIND ]---------------------------------------------
#
			'LAST_POST_IMG' => $last_post_url, 

# 
#-----[ REPLACE WITH ]-------------------------------------- 
#
			//'LAST_POST_IMG' => $last_post_url, 
			'TOPIC_DIV_ID' => 'topic_div_' . $topic_id,
			'TOPIC_PREVIEW' => $topic_preview,
			'U_LAST_POST' => $last_post_url, 
			'LAST_POST_IMG' => '<img src="' . $images['icon_latest_reply'] .'" border="0" />',

# 
#-----[ OPEN ]---------------------------------------------
#
admin/admin_board.php

# 
#-----[ FIND ]---------------------------------------------
#
	"L_HOT_THRESHOLD" => $lang['Hot_threshold'],

# 
#-----[ AFTER, ADD ]--------------------------------------- 
# 
	"L_TOPIC_PREVIEW_LENGTH" => $lang['Topic_preview_length'],

# 
#-----[ FIND ]---------------------------------------------
#
	"HOT_TOPIC" => $new['hot_threshold'],

# 
#-----[ AFTER, ADD ]--------------------------------------- 
# 
	"TOPIC_PREVIEW_LENGTH" => $new['topic_preview_length'],

#
#-----[ OPEN ]---------------------------------------------
#
includes/bbcode.php

#
#-----[ FIND ]---------------------------------------------
# at end of file
?>

#
#-----[ BEFORE, ADD ]--------------------------------------- 
#
//
// Function strip all BBcodes (borrowed from Mouse Hover Topic Preview MOD)
//
function bbencode_strip($text)
{
	global $lang;
	// pad it with a space so we can distinguish between FALSE and matching the 1st char (index 0).
	// This is important; bbencode_quote(), bbencode_list(), and bbencode_code() all depend on it.
	$text = ' ' . $text;

	// First: If there isn't a "[" and a "]" in the message, don't bother.
	if (! (strpos($text, '[') && strpos($text, ']')) )
	{
		// Remove padding, return.
		$text = substr($text, 1);
		return $text;
	}

	$quote = $lang['Quote']; 
	$code = $lang['Code']; 
	$wrote = $lang['wrote'];

	$text = preg_replace('/\[(url|img\:[0-9a-z]+)=(.*?)\]/si', '', $text);

	$text = preg_replace('/\[quote[\:1]*\:[0-9a-z]+="([^"]*)".*?\]/si', "\n\\1 $wrote >>\n", $text);
	$text = preg_replace('/\[quote[\:1]*\:[0-9a-z]+\]/si', "\n$quote >>\n", $text);
	$text = preg_replace('/\[\/quote[\:1]*\:[0-9a-z]+\]/si', "\n<< $quote\n", $text);
	$text = preg_replace('/\[code[\:1]*\:[0-9a-z]+\]/si',  "\n$code >>\n", $text);
	$text = preg_replace('/\[\/code[\:1]*\:[0-9a-z]+\]/si', "\n<< $code\n", $text);
	$text = preg_replace('/\[(([^\s\]]+\:[0-9a-z]+)|([\/]?url[^\s\]]*))\]/si', '', $text); 

	// Remove our padding from the string..
	$text = substr($text, 1);

	return $text;
}

#
#-----[ OPEN ]---------------------------------------------
#
includes/functions.php

#
#-----[ FIND ]---------------------------------------------
# at end of file
?>

#
#-----[ BEFORE, ADD ]--------------------------------------- 
#
function get_preview_text($topic_rowset, $length)
{
	global $db, $board_config;
	global $orig_word, $replacement_word;

	$post_id_sql = '';
	if (is_array($topic_rowset))
	{
		for($i = 0; $i < count($topic_rowset); $i++)
		{
			$post_id_sql .= ( ($post_id_sql != '') ? ', ' : '') . $topic_rowset[$i]['topic_first_post_id'];
			if ($topic_rowset[$i]['topic_replies'] > 0)
			{
				$post_id_sql .= ( ($post_id_sql != '') ? ', ' : '') . $topic_rowset[$i]['topic_last_post_id'];
			}
		}
		$post_id_sql = 'IN ('. $post_id_sql . ')';
	}
	else
	{
		$post_id_sql = '= '. $topic_rowset;
	}
	$sql = 'SELECT pt.post_id, pt.post_text, pt.bbcode_uid, p.enable_smilies
		FROM ' .POSTS_TEXT_TABLE .' pt, ' . POSTS_TABLE .' p
		WHERE pt.post_id ' . $post_id_sql . '
		AND p.post_id = pt.post_id';

	//
	// query the database
	//
	if(!($result = $db->sql_query($sql)))
	{
		message_die(GENERAL_ERROR, 'Could not query preview information', '', __LINE__, __FILE__, $sql);
	}

	$post_text_list = array();

	//
	// define censored word matches
	//
	if (empty($orig_word))
	{
		$orig_word = array();
		$replacement_word = array();
		obtain_word_list($orig_word, $replacement_word);
	}

	while ( $post = $db->sql_fetchrow($result) )
	{
		//
		// do a little magic
		// note: part of this comes from mds' news script and some additional magics from Smartor
		//
		$post['post_text'] = stripslashes($post['post_text']);
		if (($length == 0) or (strlen($post['post_text']) <= $length))
		{
			$post['post_text'] = bbencode_second_pass($post['post_text'], $post['bbcode_uid']);
		}
		else // strip text for preview
		{
			$post['post_text'] = bbencode_strip($post['post_text']);
			$post['post_text'] = substr($post['post_text'], 0, $length) . '...';
		}
		//
		// Smilies
		//
		if ($post['enable_smilies'] == 1)
		{
			$post['post_text'] = smilies_pass($post['post_text']);
		}

		//
		// censor text
		//
		if (count($orig_word))
		{
			$post['post_text'] = str_replace('\"', '"', substr(@preg_replace('#(\>(((?>([^><]+|(?R)))*)\<))#se', "@preg_replace(\$orig_word, \$replacement_word, '\\0')", '>' . $post['post_text'] . '<'), 1, -1));
		}
		$post['post_text'] = str_replace("\r", '', $post['post_text']);
		$post['post_text'] = str_replace('  ', ' ', $post['post_text']);
		$post['post_text'] = str_replace("\n\n", "\n", $post['post_text']);
		$post['post_text'] = str_replace("\n", '<br />', $post['post_text']);
		$post['post_text'] = str_replace('"', '\"', $post['post_text']);
		$post_text_list[$post['post_id']] = $post['post_text'];
	}
	$db->sql_freeresult($result);

	//
	// return the result
	//
	return $post_text_list;
}

# 
#-----[ OPEN ]---------------------------------------------
#
language/lang_english/lang_admin.php

# 
#-----[ FIND ]---------------------------------------------
#
//
// That's all Folks!
// -------------------------------------------------

#
#-----[ BEFORE, ADD ]--------------------------------------- 
#
$lang['Topic_preview_length'] = 'Topic preview length';

# 
#-----[ OPEN ]---------------------------------------------
#
templates/subSilver/admin/board_config_body.tpl

# 
#-----[ FIND ]---------------------------------------------
#
		<td class="row2"><input class="post" type="text" name="hot_threshold" size="3" maxlength="4" value="{HOT_TOPIC}" /></td>
	</tr>

# 
#-----[ AFTER, ADD ]---------------------------------------
# 
	<tr>
		<td class="row1">{L_TOPIC_PREVIEW_LENGTH}</td>
		<td class="row2"><input class="post" type="text" name="topic_preview_length" size="3" maxlength="4" value="{TOPIC_PREVIEW_LENGTH}" /></td>
	</tr>

# 
#-----[ OPEN ]--------------------------------------------- 
# 
templates/subSilver/viewforum_body.tpl

#
#-----[ FIND ]---------------------------------------------
#
<form method="post" action="{S_POST_DAYS_ACTION}">

# 
#-----[ BEFORE, ADD ]---------------------------------------
# 
<script language="JavaScript" src="templates/topic_preview.js"></script>
<script language="JavaScript">
<!--
var ns4 = document.layers;
var ns6 = document.getElementById && !document.all;
var ie4 = document.all;
var the_div;
var show_type;
//-->
</script>

# 
#-----[ OPEN ]---------------------------------------------
#
templates/subSilver/overall_header.tpl

#
#-----[ FIND ]---------------------------------------------
#
/* Import the fancy styles for IE only (NS4.x doesn't use the @import function) */

# 
#-----[ BEFORE, ADD ]--------------------------------------- 
#
.preview
{
	background-color: #FFFFE6;
	border: thin solid black;
	padding: 3px;
	font-size: {T_FONTSIZE1}px;
}

# 
#-----[ OPEN ]---------------------------------------------
#
templates/subSilver/subSilver.css

#
#-----[ FIND ]---------------------------------------------
#
/* Import the fancy styles for IE only (NS4.x doesn't use the @import function) */

# 
#-----[ BEFORE, ADD ]--------------------------------------- 
#
.preview
{
	background-color: #FFFFE6;
	border: thin solid black;
	padding: 3px;
	font-size: 11px;
}

#
#-----[ DIY INSTRUCTIONS ]------------------------------------------
#

IMPORTANT!!!!!

The installation the mod is NOT completed.
For continuation of installation see:

topic_preview_part_2.mod - if you NOT have Topics Sorted By Type At Forum View by Xpert
topic_preview_part_3.mod - if you have Topics Sorted By Type At Forum View by Xpert

#
#-----[ SAVE/CLOSE ALL FILES ]--------------------------
#
# EoM